<?php

declare(strict_types=1);

namespace Drupal\ui_patterns_devel;

use Drupal\Core\DependencyInjection\ContainerBuilder;
use Drupal\Core\DependencyInjection\ServiceProviderBase;
use Symfony\Component\DependencyInjection\Reference;

/**
 * Override the ComponentValidator service.
 */
class UiPatternsDevelServiceProvider extends ServiceProviderBase {

  /**
   * {@inheritdoc}
   */
  public function alter(ContainerBuilder $container) {
    $components = [
      'Drupal\Core\Template\ComponentsTwigExtension',
      'plugin.manager.sdc',
    ];

    foreach ($components as $serviceId) {
      if ($container->hasDefinition($serviceId)) {
        $definition = $container->getDefinition($serviceId);
        $arguments = $definition->getArguments();
        foreach ($arguments as $index => $argument) {
          if ((string) $argument === 'Drupal\Core\Theme\Component\ComponentValidator') {
            $definition->replaceArgument($index, new Reference('Drupal\ui_patterns_devel\Component\ComponentValidator'));
          }
        }
      }
    }
  }

}
