<?php

declare(strict_types=1);

namespace Drupal\ui_patterns_views\Plugin\UiPatterns\Source;

/**
 * Plugin implementation of the source_provider.
 *
 * @Source(
 *   id = "view_rows",
 *   label = @Translation("View rows"),
 *   description = @Translation("View rows results."),
 *   prop_types = {
 *      "slot"
 *    },
 * )
 */
class ViewRowsSource extends ViewsStyleSourceBase {

  /**
   * {@inheritdoc}
   */
  public function getPropValue(): mixed {

    // Get group data inside the configuration.
    $group = $this->getSettingsFromConfiguration('group');
    if (empty($group['#rows'])) {
      return ['#markup' => ''];
    }
    return $this->renderOuput($group['#rows']);
  }

}
