<?php

declare(strict_types=1);

namespace Drupal\ui_patterns_views\Plugin\UiPatterns\Source;

use Drupal\views\ViewExecutable;

/**
 * Plugin implementation of the source.
 *
 * @Source(
 *   id = "view_title",
 *   label = @Translation("View title"),
 *    description = @Translation("The title of the view."),
 *   prop_types = {
 *       "string"
 *     },
 *  )
 */
class ViewTitleSource extends ViewsSourceBase {

  /**
   * {@inheritdoc}
   */
  public function getPropValue(): mixed {
    // Get view data inside the configuration.
    $view = $this->getSettingsFromConfiguration('view');

    if (empty($view) || !$view instanceof ViewExecutable) {
      return ['#markup' => ''];
    }
    return $this->renderOuput($view->getTitle());
  }

}
