<?php

declare(strict_types=1);

namespace Drupal\ui_patterns_views\Plugin\UiPatterns\Source;

use Drupal\Core\Plugin\Context\ContextDefinition;
use Drupal\Core\Plugin\Context\EntityContextDefinition;

/**
 * Plugin base source to handle the views style plugin.
 */
abstract class ViewsStyleSourceBase extends ViewsSourceBase {

  /**
   * {@inheritdoc}
   */
  public function getContextDefinitions() {
    // Context for views entity type.
    $entity_context = EntityContextDefinition::fromEntityTypeId('view')
      ->setRequired()
      ->setLabel('Views');
    $plugin_type_context = new ContextDefinition('string');
    $plugin_type_context
      ->setRequired()
      ->addConstraint('AllowedValues', ['style']);
    return [
      'entity' => $entity_context,
      'plugin_type' => $plugin_type_context,
    ];
  }

}
